#pragma once
#include "Controllers.h"
#include "KShape.h"
#include "KVector2d.h"

namespace KapitanGame {
	class KInput;

	class KPlayerController
	{
	public:
		explicit KPlayerController(const Controllers controller) : Input(0.f, 0.f), Controller(controller)
		{
		}

		void SetupInputBindings(KInput& input);
		void MoveYAxis(float axis);
		void MoveXAxis(float axis);
		void Update(float deltaTime);
	private:
		KVector2D Input;
		Controllers Controller;
		KPawn Pawn;
	};
	typedef void (KPlayerController::* KPlayerCommand)();
	typedef void (KPlayerController::* KPlayerAxisCommand)(float input);
}


