#pragma once
#include "KShape.h"

namespace KapitanGame {
	class KRect final : public KShape
	{
	public:
		KRect(const KVector2D& position, const KVector2D& velocity, const KTexture& texture, float width, float height);
		void CollisionDetectionWithMapStep(const SDL_Rect& map) override;
		float GetWidth() const;
		float GetHeight() const;
		static KVector2D GetSeparationVector(float left, float right, float top, float bottom);
	protected:
		KVector2D GetSeparationVector(const KCircle& other) const override;
		KVector2D GetSeparationVector(const KRect& other) const override;
		bool IsCollision(const KCircle& other) const override;
		bool IsCollision(const KRect& other) const override;
	private:
		float Width;
		float Height;
	};
}


